# Example:
#   2018-05-15_09:07:01.52450 web-01 unicorn: forwarding USR2 to unicorn master 26896
<source>
  @type tail
  tag unicorn.current
  path /var/log/gitlab/unicorn/current
  pos_file /var/log/td-agent/unicorn.log.pos
  format /^(?<time>[^\s]*) (?<hostname>[^\s]*) unicorn: (?<message>(.*))/
  # Example: 2018-05-23_13:17:37.28098
  time_format %Y-%m-%d_%H:%M:%S
</source>

# Example:
#   E, [2018-05-23T09:56:32.198525 #49897] ERROR -- : reaped #<Process::Status: pid 8022 SIGKILL (signal 9)> worker=6
<source>
  @type tail
  tag unicorn.stderr
  path /var/log/gitlab/unicorn/unicorn_stderr.log
  pos_file /var/log/td-agent/unicorn_stderr.log.pos
  format /^(?<type>[^\s]*), \[(?<time>[^\]]*) \#(?<pid>[^ ]*)\]\s+(?<typelong>[^\s]*)[\s:\-]*(?<message>(.*).*)/
  # Example: 2018-05-24T09:27:29.471297
  time_format %Y-%m-%dT%H:%M:%S
</source>


# Example:
#   I, [2018-05-23T09:54:46.585975 #55972]  INFO -- omniauth: (google_oauth2) Request phase initiated.
<source>
  @type tail
  tag unicorn.stdout
  path /var/log/gitlab/unicorn/unicorn_stdout.log
  pos_file /var/log/td-agent/unicorn_stdoutlog.pos
  format /^(?<type>[^\s]*), \[(?<time>[^\]]*) \#(?<pid>[^ ]*)\]\s+(?<typelong>[^\s]*)[\s:\-]*(?<message>(.*).*)/
  # Example: 2018-05-24T09:27:29.471297
  time_format %Y-%m-%dT%H:%M:%S
</source>


## filter: hostname is not set on the unicorn logs
<filter unicorn.*>
  @type record_transformer
  <record>
<%= render "partial_default_record_attributes.erb" %>
  </record>
</filter>

<match unicorn.*>
  @type copy
  <% if node['gitlab_fluentd']['pubsub_enable'] -%>
  <store>
    @type cloud_pubsub
    topic pubsub-unicorn-inf-<%= node['gitlab_fluentd']['pubsub_env'] %>
    project <%= node['gitlab_fluentd']['pubsub_project'] %>
    <% if node['gitlab_fluentd']['pubsub_key'] -%>
    key <%= node['gitlab_fluentd']['pubsub_file'] %>
    <% end -%>
  </store>
  <% end -%>

<%= render "partial_stackdriver.erb" %>
  @include ../prometheus-mixin.conf
</match>
